码迷,mamicode.com
首页 > 其他好文 > 详细

leetcode - Contains Duplicate III

时间:2015-06-02 11:21:48      阅读:90      评论:0      收藏:0      [点我收藏+]

标签:c++   程序员   面试   二分查找   

题目:

Contains Duplicate III

 

Given an array of integers, find out whether there are two distinct indices i and j in the array such that the difference between nums[i] and nums[j] is at most t and the difference between i and j is at most k.


分析:

    利用multiset进行BST的二分搜索。lower_bound()返回一个迭代器,指向大于等于输入值的第一个元素。

    从左到右扫描数组,若multiset的元素数量等于k+1,则删去最先进入的元素。由于multiset.size()始终小于等于k+1,所以下标之差是肯定小于等于k的。然后利用lower_bound(),找到第一个大于等于nums[i]-t的元素,若该元素和nums[i]的差的绝对值小于等于t,则返回真。

   注意:为了防止溢出,必须将数据转化为long long进行处理!

class Solution {
public:
    bool containsNearbyAlmostDuplicate(vector<int>& nums, int k, int t) {
        if(nums.size()<=1 || k<1 || t<0)
            return false;
            
        multiset<long long> mset;
        long long long_t=t;
        
        for(int i=0;i<nums.size();++i)
        {
            if(mset.size()==k+1)
            {
                auto it=mset.find(nums[i-k-1]);
                mset.erase(it);
            }
            long long tmp=nums[i];
            auto it=mset.lower_bound(tmp-long_t);
            if(it!=mset.end())
            {
                long long diff=*it>tmp?*it-tmp:tmp-*it;
                if(diff<=long_t)
                    return true;
            }
            mset.emplace(nums[i]);
        }
        return false;
    }
};






leetcode - Contains Duplicate III

标签:c++   程序员   面试   二分查找   

原文地址:http://blog.csdn.net/bupt8846/article/details/46324253

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!